#include <iostream>
#include <vector>
#include <cmath>
#define ull int
#define endl '\n'
using namespace std;
ull a[250'000+10], n;
const ull MAX=2'000'000'000;
vector<ull> occ[65536+10];
bool checked[65536+10];
ull solve(ull idx1, ull idx2) {
    return abs((n-1-idx1)-idx2);
}
ull firstInGreaterThan(vector<ull> k, ull d) {
    int l=0,r=k.size()-1,m;
    while(l<=r) {
        m=(l+r)/2;
        if(d>a[k[m]]) l=m;
        else r=m;
        if(l==r || l==r-1) return m;
    }
    return m;
}
ull f(ull i) {
    checked[i]=1;
    ull br=MAX;
    if(occ[i].size()<2) return MAX;
    for(ull j = 0; j < occ[i].size(); j++) {
        for(ull k = firstInGreaterThan(occ[i], n-occ[i][j]-1)+1; k < occ[i].size(); k++) {
            br=min(solve(occ[i][k], occ[i][j]), br);
        }
    }
    return br;
}
void fastIO() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
}
int main() {
    fastIO();
    ull br=MAX;
    cin >> n;
    if(n<2) {cout << 0; return 0;}
    for(ull i = 0; i < n; i++) {
        cin >> a[i];
        //cout << "occ[" << a[i] << "].push(" << i << ");" << endl;
        occ[a[i]].push_back(i);
    }
    for(ull i = 0; i < n; i++) {
        if(checked[a[i]]) continue;
        //cout << a[i] << "=>" << f(a[i]) << endl;
        br=min(br, f(a[i]));
    }
    cout << br;
}
